﻿using Caliburn.Micro;
using System.ComponentModel.Composition;
using VisualComponents.UX.Shared;

namespace Plugin.ContextChange
{
    [Export(typeof(IPlugin))]
    public class RegisterRibbon : IPlugin
    {
        public void Exit()
        {
            
        }

        public void Initialize()
        {
            registerUXSite_And_ActionItem();
        }

        private void registerUXSite_And_ActionItem()
        {
            var cmdReg = IoC.Get<ICommandRegistry>();
            var uxConfig = IoC.Get<IUXConfiguration>();

            // Tab or Ribbon

            // You can do this
            //var ribbon = new UXSiteSetup();
            //ribbon.UXSiteIdPath = CustomRibbon.ID;
            //ribbon.UXSiteType = UXSiteType.Tab;
            //uxConfig.RegisterSite(ribbon);

            // or do this. It's all good.
            var ribbon = new UXSiteSetup
            {
                UXSiteIdPath = CustomRibbon.ID,
                UXSiteType = UXSiteType.Tab
            };
            uxConfig.RegisterSite(ribbon);

            // Group
            var ribbonGroup = new UXSiteSetup
            {
                UXSiteIdPath = CustomRibbon.ID + "/" + CustomRibbonGroup.ID,
                UXSiteType = UXSiteType.RibbonGroup
            };
            uxConfig.RegisterSite(ribbonGroup);

            // Action Item
            var actionItem = cmdReg.FindItem(CustomActionItem.CustomActionItemId);
            var item = new UXSiteSetup
            {
                UXSiteIdPath = CustomRibbon.ID + "/" + CustomRibbonGroup.ID,
                EntryId = actionItem.Id
            };
            cmdReg.RegisterActionItem(actionItem, item);        
        }
    }
}
